#!/usr/bin/python

import sys
"""./[configure].py 32 2 subportOutputAction crossbar EXdropPRencore bernoulli_iid_nonuniform 1 0.99 0.5"""


N = int(sys.argv[1])
B = int(sys.argv[2])
O = str(sys.argv[3])
F = str(sys.argv[4])
A = str(sys.argv[5])
T = str(sys.argv[6])
S = int(sys.argv[7])
L = float(sys.argv[8])
U = float(sys.argv[9])

config_file = open("/Users/n_skalis/iCode/Xcode/iSIM/src/_debug/[sim_config]", "w")
config_file.write("# ../sim -l1000000 -t1 -s1 -e1 \n")
config_file.write("Numswitches \t 1 \n")
config_file.write("Switch \t\t 0 \n")
config_file.write("\t Numinputs \t\t "+ str(N) +"\n")
config_file.write("\t Numoutputs \t\t "+ str(N) +"\n")
config_file.write("\t Numinternalbuffers \t "+ str(B) +"\n")
config_file.write("\t InputAction  \t defaultInputAction \t -o\n")
config_file.write("\t OutputAction  \t "+ O +"\n")
config_file.write("\t Fabric \t "+ F +"\n")
config_file.write("\t Algorithm \t "+ A +"\n")

traffic = T
for i in range(0, N, 1) :
	if (T == "bernoulli_iid_uniform") : traffic = "bernoulli_iid_nonuniform"
	if (T == "bursty") : traffic = "bursty_nonuniform"
	"""config_file.write("\t " + str(i) + "\t " + traffic + "\t -b 100" + "\t -u ")"""
	config_file.write("\t " + str(i) + "\t " + traffic + "\t -u ")
	for j in range(0, N, 1) :
		if (T == "bernoulli_iid_nonuniform") or (T == "bursty_nonuniform") :
			if i == j : utilization = L*( U + float(1-U)/float(N) )
			if i != j : utilization = L*( float(1-U)/float(N) )
		if (T == "bernoulli_iid_uniform") or (T == "bursty") :
			U = 0
			if i == j : utilization = L*( U + float(1-U)/float(N) )
			if i != j : utilization = L*( float(1-U)/float(N) )
		config_file.write(str(utilization))
		config_file.write(" ")
	config_file.write(" \n")

config_file.write("\t Stats \n")
config_file.write("\t \t Arrivals \n")
config_file.write("\t \t Departures \n")
config_file.write("\t \t Latency \n")
config_file.write("\t \t Occupancy \n")
config_file.write("\t Histograms \n")
config_file.write("\t \t Arrivals \n")
config_file.write("\t \t Departures \n")
config_file.write("\t \t Latency \n")
config_file.write("\t \t Occupancy \n")
config_file.close()